#include <stdio.h>
#include "cChain.h"

CChain::CChain(FILE *FD)
{
	this->FDat = FD;
	Queue = new CSQueue();
	rmArray = new CRifleMan* [rmNumber];
	char rmName[10];

	for (int i=0; i<rmNumber; i++) {
		sprintf(rmName, "A2_%.2d", i+1);
		rmArray[i] = new CRifleMan(Queue, FD, i+1, rmName);
	}
	
	Officer = new COfficer(Queue, FD);
}


CChain::~CChain()
{
	for (int i=0; i<rmNumber; i++) delete rmArray[i];
	delete [] rmArray;
	delete Officer;
	delete Queue;
}


//  ""
void CChain::DoCommand()
{
	Queue->AddMessage(new CSMessage(1, -1));
}


//  
void CChain::LogicSW()
{
	CSMessage *msg;
	
	Officer->Update();
	for (int i=0; i<rmNumber; i++) rmArray[i]->Update(); 
	
	Queue->AddMessage(new CSMessage());
	while (!Queue ->IsEmpty()) {
		msg = Queue->GetMessage();
		Officer->A(*msg);
		for (i=0; i<rmNumber; i++) rmArray[i]->A(*msg); 
		delete msg;
	}

	Officer->S();
	for (i=0; i<rmNumber; i++) rmArray[i]->S(); 

}


// 
void CChain::Output(int step)
{
	fprintf(FDat, "\n\n%.2i. logic entrance", step);
	Officer->PrintRec();
	for (int i=0; i<rmNumber; i++) {
		rmArray[i]->PrintRec();
	}
}
