#include <stdio.h>
#include "cRifleMan.h"


static const int rifleman_snum = 4;
static int	 rifleman_narr[rifleman_snum] = {0, 1, 2, 3};
static char* rifleman_carr[rifleman_snum] = {"DREAM", "ORDER", "READY", "FIRE "};


CRifleMan::CRifleMan(CSQueue * queue, FILE *f_rec, int rmID, char *rmName)
:CSAutomate(queue, rmName, new CSStateArray(rifleman_snum, rifleman_narr, rifleman_carr), f_rec, true)
{
	pID = rmID;
	bAmount = 0;
}


//    A2
void CRifleMan::A(CSMessage &msg)
{
	int ev = Translate(msg);
	switch (y_o) {
	case 0:
		if (ev == 1)			{ y_n = 1; action = 1; }
		break;

	case 1:
		if (x1() || ev == 2)	{ y_n = 2; action = 3; }
		break;

	case 2:
		if (x2())				{ y_n = 3; action = 3; }
		else					{ action = 2; }
		break;

	case 3:
		if (x3())				{ y_n = 0; action = 5; }
		else					{ action = 4; }
	}
}


// ,   A2
void CRifleMan::S()
{
	switch (action) {
	case 1: z1(); break;
	case 2: z2(); break;
	case 3: z2(); z3(); break;
	case 4: z4(); break;
	case 5: z5(); break;
	}
}


// 
void CRifleMan::PrintRec()
{
	CSAutomate::PrintRec();
	fprintf(f_rec, " bullets %i/%i", bAmount, mSize);
}


//  
int CRifleMan::Translate(CSMessage &msg)
{
	if (msg.id == 1 && msg.src == pID-1) return 1;	// e1:    
	if (msg.id == 2 && msg.src == pID+1) return 2;	// e2:     
	return 0;
}


bool CRifleMan::x1()
{
	return (pID == rmNumber);
}

bool CRifleMan::x2()
{
	return (pNumber == 0);
}

bool CRifleMan::x3()
{
	return (bAmount == 0);
}



void CRifleMan::z1()
{
	pNumber = pID;
	bAmount = mSize;
	Queue->AddMessage(new CSMessage(1, pID));	// e1:  
}

void CRifleMan::z2()
{
	pNumber--;
}

void CRifleMan::z3()
{
	Queue->AddMessage(new CSMessage(2, pID));	// e2:   
}

void CRifleMan::z4()
{
	bAmount--;
}

void CRifleMan::z5()
{
	Queue->AddMessage(new CSMessage(3, pID));	// e3:    
}
