#ifndef _SWITCH_MEM_INCLUDED
#define _SWITCH_MEM_INCLUDED

#include <stdio.h>

#ifndef NULL
#define NULL 0
#endif


class CSMessage {
public:	
	long int	id;						//   (  )
	long int	src;					//     ()

	CSMessage(long int	id	 = -1,		//    
			  long int	src	 = -1);		//  - 
};


class CSQueue {							//  !!  

	class CSQueueItem {					//  
	public:
		CSMessage	*msg;				//  
		CSQueueItem *next;				//   
		CSQueueItem(CSMessage *msg);	//   
	};

public:	
	CSQueue();							//   
	~CSQueue();							//  
	bool IsEmpty();						//   
	bool AddMessage(CSMessage *msg);	//    
	CSMessage *GetMessage();			//    

protected:
	CSQueueItem *first;					//   
	CSQueueItem *last;					//   
};


struct CSAutoState {
public:
	int number;
	char *caption;
};


class CSStateArray {
public:
	CSStateArray(int size,				//  
		int num_arr [],					//   
		char *cap_arr []);				//   
	~CSStateArray();					// 
	char *Caption(int state);			//     

private:
	int size;							//  
	CSAutoState *data;					//  

	int BinSearch(int state);			//     
};


class CSAutomate {
public:
	
	CSAutomate(CSQueue *queue,			//    
		char *automate_id,				//  
		CSStateArray *st_arr = NULL,	//   
		FILE *f_rec = NULL,				//       
		bool recording = false);		//   
	~CSAutomate();

	virtual void A(CSMessage &msg) = 0;	//   (   )
	virtual void S() = 0;				//  

	void StartRec();					//   
	void PrintRec();					//    
	void StopRec();						//   
	void Update();						//    
	int  GetState();					//   

protected:
	char *AutomateID;					//  
	CSQueue *Queue;						//    

	int y_o, y_n;						//        
	int priority;						// ,   
	int action;							//   

	CSStateArray *st_arr;				//   
	FILE *f_rec;						//    
	bool recording;						//  
};


#endif
